"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _icons = require("@ant-design/icons");

var _UIApiContext = _interopRequireDefault(require("../UIApiContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var LogPanel = function LogPanel(_ref) {
  var loading = _ref.loading;

  var _useContext = (0, _react.useContext)(_UIApiContext.default),
      api = _useContext.api;

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      logs = _useState2[0],
      setLogs = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      terminalRef = _useState4[0],
      setTerminalRef = _useState4[1];

  var Terminal = api.Terminal;
  (0, _react.useEffect)(function () {
    if (!terminalRef) {
      return;
    }
    /**
     * 获取上次安装的日志
     * 安装完成会清空
     */


    api.callRemote({
      type: 'org.umi.block.get-adding-blocks-log'
    }).then(function (_ref2) {
      var data = _ref2.data;

      if (terminalRef) {
        terminalRef.write(data.replace(/\n/g, '\r\n'));
      }
    });
    var tempLogs = [];
    /**
     *监听日志，每次会 push 一条
     */

    api.listenRemote({
      type: 'org.umi.block.add-blocks-log',
      onMessage: function onMessage(_ref3) {
        var data = _ref3.data;
        tempLogs.push(data);

        if (terminalRef) {
          terminalRef.write(data.replace(/\n/g, '\r\n'));
        }

        setLogs([].concat(tempLogs));
      }
    });
  }, [terminalRef]);

  if (!Terminal) {
    return null;
  }

  return _react.default.createElement(Terminal, {
    title: loading ? _react.default.createElement(_icons.Loading, null) : ' ',
    defaultValue: logs.join(''),
    onInit: function onInit(terminal) {
      setTerminalRef(terminal);
    },
    config: api.isMini() ? {
      fontSize: 12,
      lineHeight: 0.8
    } : {}
  });
};

var _default = LogPanel;
exports.default = _default;